"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdateMetadata = exports.InspiImageData = exports.VendorWebImageData = exports.rotateToJSON = exports.rotateFromJSON = exports.Rotate = exports.protobufPackage = void 0;
/* eslint-disable */
const long_1 = __importDefault(require("long"));
const _m0 = __importStar(require("protobufjs/minimal"));
const timestamp_1 = require("../../google/protobuf/timestamp");
exports.protobufPackage = "sgt.content.v2";
var Rotate;
(function (Rotate) {
    Rotate[Rotate["ROTATE_NONE"] = 0] = "ROTATE_NONE";
    Rotate[Rotate["ROTATE_90"] = 1] = "ROTATE_90";
    Rotate[Rotate["ROTATE_180"] = 2] = "ROTATE_180";
    Rotate[Rotate["ROTATE_270"] = 3] = "ROTATE_270";
    Rotate[Rotate["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(Rotate = exports.Rotate || (exports.Rotate = {}));
function rotateFromJSON(object) {
    switch (object) {
        case 0:
        case "ROTATE_NONE":
            return Rotate.ROTATE_NONE;
        case 1:
        case "ROTATE_90":
            return Rotate.ROTATE_90;
        case 2:
        case "ROTATE_180":
            return Rotate.ROTATE_180;
        case 3:
        case "ROTATE_270":
            return Rotate.ROTATE_270;
        case -1:
        case "UNRECOGNIZED":
        default:
            return Rotate.UNRECOGNIZED;
    }
}
exports.rotateFromJSON = rotateFromJSON;
function rotateToJSON(object) {
    switch (object) {
        case Rotate.ROTATE_NONE:
            return "ROTATE_NONE";
        case Rotate.ROTATE_90:
            return "ROTATE_90";
        case Rotate.ROTATE_180:
            return "ROTATE_180";
        case Rotate.ROTATE_270:
            return "ROTATE_270";
        default:
            return "UNKNOWN";
    }
}
exports.rotateToJSON = rotateToJSON;
function createBaseVendorWebImageData() {
    return {
        statusReportId: 0,
        documentType: "",
        sortOrder: 0,
        hashKey: "",
        documentExtendedAttribute: "",
        uploadKey: "",
        annotationLabel: "",
        annotationText: "",
    };
}
exports.VendorWebImageData = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.statusReportId !== 0) {
            writer.uint32(8).int64(message.statusReportId);
        }
        if (message.documentType !== "") {
            writer.uint32(18).string(message.documentType);
        }
        if (message.sortOrder !== 0) {
            writer.uint32(24).int64(message.sortOrder);
        }
        if (message.hashKey !== "") {
            writer.uint32(34).string(message.hashKey);
        }
        if (message.documentExtendedAttribute !== "") {
            writer.uint32(42).string(message.documentExtendedAttribute);
        }
        if (message.uploadKey !== "") {
            writer.uint32(50).string(message.uploadKey);
        }
        if (message.annotationLabel !== "") {
            writer.uint32(58).string(message.annotationLabel);
        }
        if (message.annotationText !== "") {
            writer.uint32(66).string(message.annotationText);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseVendorWebImageData();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.statusReportId = longToNumber(reader.int64());
                    break;
                case 2:
                    message.documentType = reader.string();
                    break;
                case 3:
                    message.sortOrder = longToNumber(reader.int64());
                    break;
                case 4:
                    message.hashKey = reader.string();
                    break;
                case 5:
                    message.documentExtendedAttribute = reader.string();
                    break;
                case 6:
                    message.uploadKey = reader.string();
                    break;
                case 7:
                    message.annotationLabel = reader.string();
                    break;
                case 8:
                    message.annotationText = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            statusReportId: isSet(object.statusReportId)
                ? Number(object.statusReportId)
                : 0,
            documentType: isSet(object.documentType)
                ? String(object.documentType)
                : "",
            sortOrder: isSet(object.sortOrder) ? Number(object.sortOrder) : 0,
            hashKey: isSet(object.hashKey) ? String(object.hashKey) : "",
            documentExtendedAttribute: isSet(object.documentExtendedAttribute)
                ? String(object.documentExtendedAttribute)
                : "",
            uploadKey: isSet(object.uploadKey) ? String(object.uploadKey) : "",
            annotationLabel: isSet(object.annotationLabel)
                ? String(object.annotationLabel)
                : "",
            annotationText: isSet(object.annotationText)
                ? String(object.annotationText)
                : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.statusReportId !== undefined &&
            (obj.statusReportId = Math.round(message.statusReportId));
        message.documentType !== undefined &&
            (obj.documentType = message.documentType);
        message.sortOrder !== undefined &&
            (obj.sortOrder = Math.round(message.sortOrder));
        message.hashKey !== undefined && (obj.hashKey = message.hashKey);
        message.documentExtendedAttribute !== undefined &&
            (obj.documentExtendedAttribute = message.documentExtendedAttribute);
        message.uploadKey !== undefined && (obj.uploadKey = message.uploadKey);
        message.annotationLabel !== undefined &&
            (obj.annotationLabel = message.annotationLabel);
        message.annotationText !== undefined &&
            (obj.annotationText = message.annotationText);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d, _e, _f, _g, _h;
        const message = createBaseVendorWebImageData();
        message.statusReportId = (_a = object.statusReportId) !== null && _a !== void 0 ? _a : 0;
        message.documentType = (_b = object.documentType) !== null && _b !== void 0 ? _b : "";
        message.sortOrder = (_c = object.sortOrder) !== null && _c !== void 0 ? _c : 0;
        message.hashKey = (_d = object.hashKey) !== null && _d !== void 0 ? _d : "";
        message.documentExtendedAttribute = (_e = object.documentExtendedAttribute) !== null && _e !== void 0 ? _e : "";
        message.uploadKey = (_f = object.uploadKey) !== null && _f !== void 0 ? _f : "";
        message.annotationLabel = (_g = object.annotationLabel) !== null && _g !== void 0 ? _g : "";
        message.annotationText = (_h = object.annotationText) !== null && _h !== void 0 ? _h : "";
        return message;
    },
};
function createBaseInspiImageData() {
    return { isFrontOfHouse: false, mainVendorCode: "", vendorCodeUploaded: "" };
}
exports.InspiImageData = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.isFrontOfHouse === true) {
            writer.uint32(8).bool(message.isFrontOfHouse);
        }
        if (message.mainVendorCode !== "") {
            writer.uint32(18).string(message.mainVendorCode);
        }
        if (message.vendorCodeUploaded !== "") {
            writer.uint32(26).string(message.vendorCodeUploaded);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseInspiImageData();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.isFrontOfHouse = reader.bool();
                    break;
                case 2:
                    message.mainVendorCode = reader.string();
                    break;
                case 3:
                    message.vendorCodeUploaded = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            isFrontOfHouse: isSet(object.isFrontOfHouse)
                ? Boolean(object.isFrontOfHouse)
                : false,
            mainVendorCode: isSet(object.mainVendorCode)
                ? String(object.mainVendorCode)
                : "",
            vendorCodeUploaded: isSet(object.vendorCodeUploaded)
                ? String(object.vendorCodeUploaded)
                : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.isFrontOfHouse !== undefined &&
            (obj.isFrontOfHouse = message.isFrontOfHouse);
        message.mainVendorCode !== undefined &&
            (obj.mainVendorCode = message.mainVendorCode);
        message.vendorCodeUploaded !== undefined &&
            (obj.vendorCodeUploaded = message.vendorCodeUploaded);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c;
        const message = createBaseInspiImageData();
        message.isFrontOfHouse = (_a = object.isFrontOfHouse) !== null && _a !== void 0 ? _a : false;
        message.mainVendorCode = (_b = object.mainVendorCode) !== null && _b !== void 0 ? _b : "";
        message.vendorCodeUploaded = (_c = object.vendorCodeUploaded) !== null && _c !== void 0 ? _c : "";
        return message;
    },
};
function createBaseUpdateMetadata() {
    return {
        orderNumber: 0,
        propertyId: 0,
        imageType: 0,
        imageWidth: 0,
        imageHeight: 0,
        contractorId: 0,
        departmentCode: "",
        description: "",
        prefix: "",
        category: "",
        scanDate: undefined,
        releaseDate: undefined,
        source: "",
        guid: "",
    };
}
exports.UpdateMetadata = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.orderNumber !== 0) {
            writer.uint32(8).int64(message.orderNumber);
        }
        if (message.propertyId !== 0) {
            writer.uint32(16).int64(message.propertyId);
        }
        if (message.imageType !== 0) {
            writer.uint32(24).int64(message.imageType);
        }
        if (message.imageWidth !== 0) {
            writer.uint32(32).int64(message.imageWidth);
        }
        if (message.imageHeight !== 0) {
            writer.uint32(40).int64(message.imageHeight);
        }
        if (message.contractorId !== 0) {
            writer.uint32(48).int64(message.contractorId);
        }
        if (message.departmentCode !== "") {
            writer.uint32(58).string(message.departmentCode);
        }
        if (message.description !== "") {
            writer.uint32(66).string(message.description);
        }
        if (message.prefix !== "") {
            writer.uint32(74).string(message.prefix);
        }
        if (message.category !== "") {
            writer.uint32(82).string(message.category);
        }
        if (message.scanDate !== undefined) {
            timestamp_1.Timestamp.encode(toTimestamp(message.scanDate), writer.uint32(90).fork()).ldelim();
        }
        if (message.releaseDate !== undefined) {
            timestamp_1.Timestamp.encode(toTimestamp(message.releaseDate), writer.uint32(98).fork()).ldelim();
        }
        if (message.source !== "") {
            writer.uint32(106).string(message.source);
        }
        if (message.guid !== "") {
            writer.uint32(114).string(message.guid);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseUpdateMetadata();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.orderNumber = longToNumber(reader.int64());
                    break;
                case 2:
                    message.propertyId = longToNumber(reader.int64());
                    break;
                case 3:
                    message.imageType = longToNumber(reader.int64());
                    break;
                case 4:
                    message.imageWidth = longToNumber(reader.int64());
                    break;
                case 5:
                    message.imageHeight = longToNumber(reader.int64());
                    break;
                case 6:
                    message.contractorId = longToNumber(reader.int64());
                    break;
                case 7:
                    message.departmentCode = reader.string();
                    break;
                case 8:
                    message.description = reader.string();
                    break;
                case 9:
                    message.prefix = reader.string();
                    break;
                case 10:
                    message.category = reader.string();
                    break;
                case 11:
                    message.scanDate = fromTimestamp(timestamp_1.Timestamp.decode(reader, reader.uint32()));
                    break;
                case 12:
                    message.releaseDate = fromTimestamp(timestamp_1.Timestamp.decode(reader, reader.uint32()));
                    break;
                case 13:
                    message.source = reader.string();
                    break;
                case 14:
                    message.guid = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            orderNumber: isSet(object.orderNumber) ? Number(object.orderNumber) : 0,
            propertyId: isSet(object.propertyId) ? Number(object.propertyId) : 0,
            imageType: isSet(object.imageType) ? Number(object.imageType) : 0,
            imageWidth: isSet(object.imageWidth) ? Number(object.imageWidth) : 0,
            imageHeight: isSet(object.imageHeight) ? Number(object.imageHeight) : 0,
            contractorId: isSet(object.contractorId)
                ? Number(object.contractorId)
                : 0,
            departmentCode: isSet(object.departmentCode)
                ? String(object.departmentCode)
                : "",
            description: isSet(object.description) ? String(object.description) : "",
            prefix: isSet(object.prefix) ? String(object.prefix) : "",
            category: isSet(object.category) ? String(object.category) : "",
            scanDate: isSet(object.scanDate)
                ? fromJsonTimestamp(object.scanDate)
                : undefined,
            releaseDate: isSet(object.releaseDate)
                ? fromJsonTimestamp(object.releaseDate)
                : undefined,
            source: isSet(object.source) ? String(object.source) : "",
            guid: isSet(object.guid) ? String(object.guid) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.orderNumber !== undefined &&
            (obj.orderNumber = Math.round(message.orderNumber));
        message.propertyId !== undefined &&
            (obj.propertyId = Math.round(message.propertyId));
        message.imageType !== undefined &&
            (obj.imageType = Math.round(message.imageType));
        message.imageWidth !== undefined &&
            (obj.imageWidth = Math.round(message.imageWidth));
        message.imageHeight !== undefined &&
            (obj.imageHeight = Math.round(message.imageHeight));
        message.contractorId !== undefined &&
            (obj.contractorId = Math.round(message.contractorId));
        message.departmentCode !== undefined &&
            (obj.departmentCode = message.departmentCode);
        message.description !== undefined &&
            (obj.description = message.description);
        message.prefix !== undefined && (obj.prefix = message.prefix);
        message.category !== undefined && (obj.category = message.category);
        message.scanDate !== undefined &&
            (obj.scanDate = message.scanDate.toISOString());
        message.releaseDate !== undefined &&
            (obj.releaseDate = message.releaseDate.toISOString());
        message.source !== undefined && (obj.source = message.source);
        message.guid !== undefined && (obj.guid = message.guid);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p;
        const message = createBaseUpdateMetadata();
        message.orderNumber = (_a = object.orderNumber) !== null && _a !== void 0 ? _a : 0;
        message.propertyId = (_b = object.propertyId) !== null && _b !== void 0 ? _b : 0;
        message.imageType = (_c = object.imageType) !== null && _c !== void 0 ? _c : 0;
        message.imageWidth = (_d = object.imageWidth) !== null && _d !== void 0 ? _d : 0;
        message.imageHeight = (_e = object.imageHeight) !== null && _e !== void 0 ? _e : 0;
        message.contractorId = (_f = object.contractorId) !== null && _f !== void 0 ? _f : 0;
        message.departmentCode = (_g = object.departmentCode) !== null && _g !== void 0 ? _g : "";
        message.description = (_h = object.description) !== null && _h !== void 0 ? _h : "";
        message.prefix = (_j = object.prefix) !== null && _j !== void 0 ? _j : "";
        message.category = (_k = object.category) !== null && _k !== void 0 ? _k : "";
        message.scanDate = (_l = object.scanDate) !== null && _l !== void 0 ? _l : undefined;
        message.releaseDate = (_m = object.releaseDate) !== null && _m !== void 0 ? _m : undefined;
        message.source = (_o = object.source) !== null && _o !== void 0 ? _o : "";
        message.guid = (_p = object.guid) !== null && _p !== void 0 ? _p : "";
        return message;
    },
};
var globalThis = (() => {
    if (typeof globalThis !== "undefined")
        return globalThis;
    if (typeof self !== "undefined")
        return self;
    if (typeof window !== "undefined")
        return window;
    if (typeof global !== "undefined")
        return global;
    throw "Unable to locate global object";
})();
function toTimestamp(date) {
    const seconds = date.getTime() / 1000;
    const nanos = (date.getTime() % 1000) * 1000000;
    return { seconds, nanos };
}
function fromTimestamp(t) {
    let millis = t.seconds * 1000;
    millis += t.nanos / 1000000;
    return new Date(millis);
}
function fromJsonTimestamp(o) {
    if (o instanceof Date) {
        return o;
    }
    else if (typeof o === "string") {
        return new Date(o);
    }
    else {
        return fromTimestamp(timestamp_1.Timestamp.fromJSON(o));
    }
}
function longToNumber(long) {
    if (long.gt(Number.MAX_SAFE_INTEGER)) {
        throw new globalThis.Error("Value is larger than Number.MAX_SAFE_INTEGER");
    }
    return long.toNumber();
}
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
