"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.S3UploadStatusData = exports.S3ProcessResult_Result = exports.S3ProcessResult = exports.S3RemoveData = exports.S3SinkData = exports.S3ExifData = exports.S3UploadData = exports.protobufPackage = void 0;
/* eslint-disable */
const long_1 = __importDefault(require("long"));
const _m0 = __importStar(require("protobufjs/minimal"));
const timestamp_1 = require("../../../google/protobuf/timestamp");
const content_v2_1 = require("../../content/content_v2");
exports.protobufPackage = "sgt.aws.lambda.s3upload.v1";
function createBaseS3UploadData() {
    return {
        correlationId: "",
        imageType: 0,
        filename: "",
        source: "",
        description: "",
        category: "",
        prefix: "",
        contractor: 0,
        departmentCode: "",
        timezoneOffset: 0,
        dateTaken: undefined,
        gpsTimestamp: undefined,
        gpsDop: 0,
        gpsAltitude: 0,
        gpsLatitude: 0,
        gpsLongitude: 0,
        orderNumber: undefined,
        propertyId: undefined,
        vendorWebImageData: undefined,
        inspiImageData: undefined,
    };
}
exports.S3UploadData = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.correlationId !== "") {
            writer.uint32(10).string(message.correlationId);
        }
        if (message.imageType !== 0) {
            writer.uint32(16).int64(message.imageType);
        }
        if (message.filename !== "") {
            writer.uint32(26).string(message.filename);
        }
        if (message.source !== "") {
            writer.uint32(34).string(message.source);
        }
        if (message.description !== "") {
            writer.uint32(42).string(message.description);
        }
        if (message.category !== "") {
            writer.uint32(50).string(message.category);
        }
        if (message.prefix !== "") {
            writer.uint32(58).string(message.prefix);
        }
        if (message.contractor !== 0) {
            writer.uint32(64).int64(message.contractor);
        }
        if (message.departmentCode !== "") {
            writer.uint32(74).string(message.departmentCode);
        }
        if (message.timezoneOffset !== 0) {
            writer.uint32(80).int32(message.timezoneOffset);
        }
        if (message.dateTaken !== undefined) {
            timestamp_1.Timestamp.encode(toTimestamp(message.dateTaken), writer.uint32(90).fork()).ldelim();
        }
        if (message.gpsTimestamp !== undefined) {
            timestamp_1.Timestamp.encode(toTimestamp(message.gpsTimestamp), writer.uint32(98).fork()).ldelim();
        }
        if (message.gpsDop !== 0) {
            writer.uint32(105).double(message.gpsDop);
        }
        if (message.gpsAltitude !== 0) {
            writer.uint32(112).int32(message.gpsAltitude);
        }
        if (message.gpsLatitude !== 0) {
            writer.uint32(121).double(message.gpsLatitude);
        }
        if (message.gpsLongitude !== 0) {
            writer.uint32(129).double(message.gpsLongitude);
        }
        if (message.orderNumber !== undefined) {
            writer.uint32(800).int64(message.orderNumber);
        }
        if (message.propertyId !== undefined) {
            writer.uint32(808).int64(message.propertyId);
        }
        if (message.vendorWebImageData !== undefined) {
            content_v2_1.VendorWebImageData.encode(message.vendorWebImageData, writer.uint32(1602).fork()).ldelim();
        }
        if (message.inspiImageData !== undefined) {
            content_v2_1.InspiImageData.encode(message.inspiImageData, writer.uint32(1610).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseS3UploadData();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.correlationId = reader.string();
                    break;
                case 2:
                    message.imageType = longToNumber(reader.int64());
                    break;
                case 3:
                    message.filename = reader.string();
                    break;
                case 4:
                    message.source = reader.string();
                    break;
                case 5:
                    message.description = reader.string();
                    break;
                case 6:
                    message.category = reader.string();
                    break;
                case 7:
                    message.prefix = reader.string();
                    break;
                case 8:
                    message.contractor = longToNumber(reader.int64());
                    break;
                case 9:
                    message.departmentCode = reader.string();
                    break;
                case 10:
                    message.timezoneOffset = reader.int32();
                    break;
                case 11:
                    message.dateTaken = fromTimestamp(timestamp_1.Timestamp.decode(reader, reader.uint32()));
                    break;
                case 12:
                    message.gpsTimestamp = fromTimestamp(timestamp_1.Timestamp.decode(reader, reader.uint32()));
                    break;
                case 13:
                    message.gpsDop = reader.double();
                    break;
                case 14:
                    message.gpsAltitude = reader.int32();
                    break;
                case 15:
                    message.gpsLatitude = reader.double();
                    break;
                case 16:
                    message.gpsLongitude = reader.double();
                    break;
                case 100:
                    message.orderNumber = longToNumber(reader.int64());
                    break;
                case 101:
                    message.propertyId = longToNumber(reader.int64());
                    break;
                case 200:
                    message.vendorWebImageData = content_v2_1.VendorWebImageData.decode(reader, reader.uint32());
                    break;
                case 201:
                    message.inspiImageData = content_v2_1.InspiImageData.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            correlationId: isSet(object.correlationId)
                ? String(object.correlationId)
                : "",
            imageType: isSet(object.imageType) ? Number(object.imageType) : 0,
            filename: isSet(object.filename) ? String(object.filename) : "",
            source: isSet(object.source) ? String(object.source) : "",
            description: isSet(object.description) ? String(object.description) : "",
            category: isSet(object.category) ? String(object.category) : "",
            prefix: isSet(object.prefix) ? String(object.prefix) : "",
            contractor: isSet(object.contractor) ? Number(object.contractor) : 0,
            departmentCode: isSet(object.departmentCode)
                ? String(object.departmentCode)
                : "",
            timezoneOffset: isSet(object.timezoneOffset)
                ? Number(object.timezoneOffset)
                : 0,
            dateTaken: isSet(object.dateTaken)
                ? fromJsonTimestamp(object.dateTaken)
                : undefined,
            gpsTimestamp: isSet(object.gpsTimestamp)
                ? fromJsonTimestamp(object.gpsTimestamp)
                : undefined,
            gpsDop: isSet(object.gpsDop) ? Number(object.gpsDop) : 0,
            gpsAltitude: isSet(object.gpsAltitude) ? Number(object.gpsAltitude) : 0,
            gpsLatitude: isSet(object.gpsLatitude) ? Number(object.gpsLatitude) : 0,
            gpsLongitude: isSet(object.gpsLongitude)
                ? Number(object.gpsLongitude)
                : 0,
            orderNumber: isSet(object.orderNumber)
                ? Number(object.orderNumber)
                : undefined,
            propertyId: isSet(object.propertyId)
                ? Number(object.propertyId)
                : undefined,
            vendorWebImageData: isSet(object.vendorWebImageData)
                ? content_v2_1.VendorWebImageData.fromJSON(object.vendorWebImageData)
                : undefined,
            inspiImageData: isSet(object.inspiImageData)
                ? content_v2_1.InspiImageData.fromJSON(object.inspiImageData)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.correlationId !== undefined &&
            (obj.correlationId = message.correlationId);
        message.imageType !== undefined &&
            (obj.imageType = Math.round(message.imageType));
        message.filename !== undefined && (obj.filename = message.filename);
        message.source !== undefined && (obj.source = message.source);
        message.description !== undefined &&
            (obj.description = message.description);
        message.category !== undefined && (obj.category = message.category);
        message.prefix !== undefined && (obj.prefix = message.prefix);
        message.contractor !== undefined &&
            (obj.contractor = Math.round(message.contractor));
        message.departmentCode !== undefined &&
            (obj.departmentCode = message.departmentCode);
        message.timezoneOffset !== undefined &&
            (obj.timezoneOffset = Math.round(message.timezoneOffset));
        message.dateTaken !== undefined &&
            (obj.dateTaken = message.dateTaken.toISOString());
        message.gpsTimestamp !== undefined &&
            (obj.gpsTimestamp = message.gpsTimestamp.toISOString());
        message.gpsDop !== undefined && (obj.gpsDop = message.gpsDop);
        message.gpsAltitude !== undefined &&
            (obj.gpsAltitude = Math.round(message.gpsAltitude));
        message.gpsLatitude !== undefined &&
            (obj.gpsLatitude = message.gpsLatitude);
        message.gpsLongitude !== undefined &&
            (obj.gpsLongitude = message.gpsLongitude);
        message.orderNumber !== undefined &&
            (obj.orderNumber = Math.round(message.orderNumber));
        message.propertyId !== undefined &&
            (obj.propertyId = Math.round(message.propertyId));
        message.vendorWebImageData !== undefined &&
            (obj.vendorWebImageData = message.vendorWebImageData
                ? content_v2_1.VendorWebImageData.toJSON(message.vendorWebImageData)
                : undefined);
        message.inspiImageData !== undefined &&
            (obj.inspiImageData = message.inspiImageData
                ? content_v2_1.InspiImageData.toJSON(message.inspiImageData)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t;
        const message = createBaseS3UploadData();
        message.correlationId = (_a = object.correlationId) !== null && _a !== void 0 ? _a : "";
        message.imageType = (_b = object.imageType) !== null && _b !== void 0 ? _b : 0;
        message.filename = (_c = object.filename) !== null && _c !== void 0 ? _c : "";
        message.source = (_d = object.source) !== null && _d !== void 0 ? _d : "";
        message.description = (_e = object.description) !== null && _e !== void 0 ? _e : "";
        message.category = (_f = object.category) !== null && _f !== void 0 ? _f : "";
        message.prefix = (_g = object.prefix) !== null && _g !== void 0 ? _g : "";
        message.contractor = (_h = object.contractor) !== null && _h !== void 0 ? _h : 0;
        message.departmentCode = (_j = object.departmentCode) !== null && _j !== void 0 ? _j : "";
        message.timezoneOffset = (_k = object.timezoneOffset) !== null && _k !== void 0 ? _k : 0;
        message.dateTaken = (_l = object.dateTaken) !== null && _l !== void 0 ? _l : undefined;
        message.gpsTimestamp = (_m = object.gpsTimestamp) !== null && _m !== void 0 ? _m : undefined;
        message.gpsDop = (_o = object.gpsDop) !== null && _o !== void 0 ? _o : 0;
        message.gpsAltitude = (_p = object.gpsAltitude) !== null && _p !== void 0 ? _p : 0;
        message.gpsLatitude = (_q = object.gpsLatitude) !== null && _q !== void 0 ? _q : 0;
        message.gpsLongitude = (_r = object.gpsLongitude) !== null && _r !== void 0 ? _r : 0;
        message.orderNumber = (_s = object.orderNumber) !== null && _s !== void 0 ? _s : undefined;
        message.propertyId = (_t = object.propertyId) !== null && _t !== void 0 ? _t : undefined;
        message.vendorWebImageData =
            object.vendorWebImageData !== undefined &&
                object.vendorWebImageData !== null
                ? content_v2_1.VendorWebImageData.fromPartial(object.vendorWebImageData)
                : undefined;
        message.inspiImageData =
            object.inspiImageData !== undefined && object.inspiImageData !== null
                ? content_v2_1.InspiImageData.fromPartial(object.inspiImageData)
                : undefined;
        return message;
    },
};
function createBaseS3ExifData() {
    return {
        gpsDop: 0,
        gpsAltitude: 0,
        gpsLatitude: 0,
        gpsLongitude: 0,
        gpsTimestamp: undefined,
        dateTimeOriginal: "",
        dateTimeDigitized: "",
        userComment: "",
        cameraMake: "",
        cameraModel: "",
        cameraOsVersion: "",
    };
}
exports.S3ExifData = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.gpsDop !== 0) {
            writer.uint32(9).double(message.gpsDop);
        }
        if (message.gpsAltitude !== 0) {
            writer.uint32(16).int32(message.gpsAltitude);
        }
        if (message.gpsLatitude !== 0) {
            writer.uint32(25).double(message.gpsLatitude);
        }
        if (message.gpsLongitude !== 0) {
            writer.uint32(33).double(message.gpsLongitude);
        }
        if (message.gpsTimestamp !== undefined) {
            timestamp_1.Timestamp.encode(toTimestamp(message.gpsTimestamp), writer.uint32(42).fork()).ldelim();
        }
        if (message.dateTimeOriginal !== "") {
            writer.uint32(50).string(message.dateTimeOriginal);
        }
        if (message.dateTimeDigitized !== "") {
            writer.uint32(58).string(message.dateTimeDigitized);
        }
        if (message.userComment !== "") {
            writer.uint32(66).string(message.userComment);
        }
        if (message.cameraMake !== "") {
            writer.uint32(74).string(message.cameraMake);
        }
        if (message.cameraModel !== "") {
            writer.uint32(82).string(message.cameraModel);
        }
        if (message.cameraOsVersion !== "") {
            writer.uint32(90).string(message.cameraOsVersion);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseS3ExifData();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.gpsDop = reader.double();
                    break;
                case 2:
                    message.gpsAltitude = reader.int32();
                    break;
                case 3:
                    message.gpsLatitude = reader.double();
                    break;
                case 4:
                    message.gpsLongitude = reader.double();
                    break;
                case 5:
                    message.gpsTimestamp = fromTimestamp(timestamp_1.Timestamp.decode(reader, reader.uint32()));
                    break;
                case 6:
                    message.dateTimeOriginal = reader.string();
                    break;
                case 7:
                    message.dateTimeDigitized = reader.string();
                    break;
                case 8:
                    message.userComment = reader.string();
                    break;
                case 9:
                    message.cameraMake = reader.string();
                    break;
                case 10:
                    message.cameraModel = reader.string();
                    break;
                case 11:
                    message.cameraOsVersion = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            gpsDop: isSet(object.gpsDop) ? Number(object.gpsDop) : 0,
            gpsAltitude: isSet(object.gpsAltitude) ? Number(object.gpsAltitude) : 0,
            gpsLatitude: isSet(object.gpsLatitude) ? Number(object.gpsLatitude) : 0,
            gpsLongitude: isSet(object.gpsLongitude)
                ? Number(object.gpsLongitude)
                : 0,
            gpsTimestamp: isSet(object.gpsTimestamp)
                ? fromJsonTimestamp(object.gpsTimestamp)
                : undefined,
            dateTimeOriginal: isSet(object.dateTimeOriginal)
                ? String(object.dateTimeOriginal)
                : "",
            dateTimeDigitized: isSet(object.dateTimeDigitized)
                ? String(object.dateTimeDigitized)
                : "",
            userComment: isSet(object.userComment) ? String(object.userComment) : "",
            cameraMake: isSet(object.cameraMake) ? String(object.cameraMake) : "",
            cameraModel: isSet(object.cameraModel) ? String(object.cameraModel) : "",
            cameraOsVersion: isSet(object.cameraOsVersion)
                ? String(object.cameraOsVersion)
                : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.gpsDop !== undefined && (obj.gpsDop = message.gpsDop);
        message.gpsAltitude !== undefined &&
            (obj.gpsAltitude = Math.round(message.gpsAltitude));
        message.gpsLatitude !== undefined &&
            (obj.gpsLatitude = message.gpsLatitude);
        message.gpsLongitude !== undefined &&
            (obj.gpsLongitude = message.gpsLongitude);
        message.gpsTimestamp !== undefined &&
            (obj.gpsTimestamp = message.gpsTimestamp.toISOString());
        message.dateTimeOriginal !== undefined &&
            (obj.dateTimeOriginal = message.dateTimeOriginal);
        message.dateTimeDigitized !== undefined &&
            (obj.dateTimeDigitized = message.dateTimeDigitized);
        message.userComment !== undefined &&
            (obj.userComment = message.userComment);
        message.cameraMake !== undefined && (obj.cameraMake = message.cameraMake);
        message.cameraModel !== undefined &&
            (obj.cameraModel = message.cameraModel);
        message.cameraOsVersion !== undefined &&
            (obj.cameraOsVersion = message.cameraOsVersion);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
        const message = createBaseS3ExifData();
        message.gpsDop = (_a = object.gpsDop) !== null && _a !== void 0 ? _a : 0;
        message.gpsAltitude = (_b = object.gpsAltitude) !== null && _b !== void 0 ? _b : 0;
        message.gpsLatitude = (_c = object.gpsLatitude) !== null && _c !== void 0 ? _c : 0;
        message.gpsLongitude = (_d = object.gpsLongitude) !== null && _d !== void 0 ? _d : 0;
        message.gpsTimestamp = (_e = object.gpsTimestamp) !== null && _e !== void 0 ? _e : undefined;
        message.dateTimeOriginal = (_f = object.dateTimeOriginal) !== null && _f !== void 0 ? _f : "";
        message.dateTimeDigitized = (_g = object.dateTimeDigitized) !== null && _g !== void 0 ? _g : "";
        message.userComment = (_h = object.userComment) !== null && _h !== void 0 ? _h : "";
        message.cameraMake = (_j = object.cameraMake) !== null && _j !== void 0 ? _j : "";
        message.cameraModel = (_k = object.cameraModel) !== null && _k !== void 0 ? _k : "";
        message.cameraOsVersion = (_l = object.cameraOsVersion) !== null && _l !== void 0 ? _l : "";
        return message;
    },
};
function createBaseS3SinkData() {
    return {
        correlationId: "",
        success: false,
        message: "",
        s3Path: "",
        orderNumber: undefined,
        propertyId: undefined,
    };
}
exports.S3SinkData = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.correlationId !== "") {
            writer.uint32(10).string(message.correlationId);
        }
        if (message.success === true) {
            writer.uint32(16).bool(message.success);
        }
        if (message.message !== "") {
            writer.uint32(26).string(message.message);
        }
        if (message.s3Path !== "") {
            writer.uint32(34).string(message.s3Path);
        }
        if (message.orderNumber !== undefined) {
            writer.uint32(800).int64(message.orderNumber);
        }
        if (message.propertyId !== undefined) {
            writer.uint32(808).int64(message.propertyId);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseS3SinkData();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.correlationId = reader.string();
                    break;
                case 2:
                    message.success = reader.bool();
                    break;
                case 3:
                    message.message = reader.string();
                    break;
                case 4:
                    message.s3Path = reader.string();
                    break;
                case 100:
                    message.orderNumber = longToNumber(reader.int64());
                    break;
                case 101:
                    message.propertyId = longToNumber(reader.int64());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            correlationId: isSet(object.correlationId)
                ? String(object.correlationId)
                : "",
            success: isSet(object.success) ? Boolean(object.success) : false,
            message: isSet(object.message) ? String(object.message) : "",
            s3Path: isSet(object.s3Path) ? String(object.s3Path) : "",
            orderNumber: isSet(object.orderNumber)
                ? Number(object.orderNumber)
                : undefined,
            propertyId: isSet(object.propertyId)
                ? Number(object.propertyId)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.correlationId !== undefined &&
            (obj.correlationId = message.correlationId);
        message.success !== undefined && (obj.success = message.success);
        message.message !== undefined && (obj.message = message.message);
        message.s3Path !== undefined && (obj.s3Path = message.s3Path);
        message.orderNumber !== undefined &&
            (obj.orderNumber = Math.round(message.orderNumber));
        message.propertyId !== undefined &&
            (obj.propertyId = Math.round(message.propertyId));
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d, _e, _f;
        const message = createBaseS3SinkData();
        message.correlationId = (_a = object.correlationId) !== null && _a !== void 0 ? _a : "";
        message.success = (_b = object.success) !== null && _b !== void 0 ? _b : false;
        message.message = (_c = object.message) !== null && _c !== void 0 ? _c : "";
        message.s3Path = (_d = object.s3Path) !== null && _d !== void 0 ? _d : "";
        message.orderNumber = (_e = object.orderNumber) !== null && _e !== void 0 ? _e : undefined;
        message.propertyId = (_f = object.propertyId) !== null && _f !== void 0 ? _f : undefined;
        return message;
    },
};
function createBaseS3RemoveData() {
    return { s3Path: "" };
}
exports.S3RemoveData = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.s3Path !== "") {
            writer.uint32(10).string(message.s3Path);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseS3RemoveData();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.s3Path = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            s3Path: isSet(object.s3Path) ? String(object.s3Path) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.s3Path !== undefined && (obj.s3Path = message.s3Path);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseS3RemoveData();
        message.s3Path = (_a = object.s3Path) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBaseS3ProcessResult() {
    return { results: [] };
}
exports.S3ProcessResult = {
    encode(message, writer = _m0.Writer.create()) {
        for (const v of message.results) {
            exports.S3ProcessResult_Result.encode(v, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseS3ProcessResult();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.results.push(exports.S3ProcessResult_Result.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            results: Array.isArray(object === null || object === void 0 ? void 0 : object.results)
                ? object.results.map((e) => exports.S3ProcessResult_Result.fromJSON(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.results) {
            obj.results = message.results.map((e) => e ? exports.S3ProcessResult_Result.toJSON(e) : undefined);
        }
        else {
            obj.results = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseS3ProcessResult();
        message.results =
            ((_a = object.results) === null || _a === void 0 ? void 0 : _a.map((e) => exports.S3ProcessResult_Result.fromPartial(e))) || [];
        return message;
    },
};
function createBaseS3ProcessResult_Result() {
    return {
        correlationId: "",
        filePath: "",
        fileSize: 0,
        fileSha1: "",
        s3ExifData: undefined,
        s3UploadData: undefined,
        thumbnailPath: "",
        thumbnailSize: 0,
        imageHeight: 0,
        imageWidth: 0,
        errorCode: 0,
        errorMessage: "",
    };
}
exports.S3ProcessResult_Result = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.correlationId !== "") {
            writer.uint32(10).string(message.correlationId);
        }
        if (message.filePath !== "") {
            writer.uint32(18).string(message.filePath);
        }
        if (message.fileSize !== 0) {
            writer.uint32(24).int64(message.fileSize);
        }
        if (message.fileSha1 !== "") {
            writer.uint32(34).string(message.fileSha1);
        }
        if (message.s3ExifData !== undefined) {
            exports.S3ExifData.encode(message.s3ExifData, writer.uint32(42).fork()).ldelim();
        }
        if (message.s3UploadData !== undefined) {
            exports.S3UploadData.encode(message.s3UploadData, writer.uint32(50).fork()).ldelim();
        }
        if (message.thumbnailPath !== "") {
            writer.uint32(58).string(message.thumbnailPath);
        }
        if (message.thumbnailSize !== 0) {
            writer.uint32(64).int64(message.thumbnailSize);
        }
        if (message.imageHeight !== 0) {
            writer.uint32(72).int64(message.imageHeight);
        }
        if (message.imageWidth !== 0) {
            writer.uint32(80).int64(message.imageWidth);
        }
        if (message.errorCode !== 0) {
            writer.uint32(800).int32(message.errorCode);
        }
        if (message.errorMessage !== "") {
            writer.uint32(810).string(message.errorMessage);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseS3ProcessResult_Result();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.correlationId = reader.string();
                    break;
                case 2:
                    message.filePath = reader.string();
                    break;
                case 3:
                    message.fileSize = longToNumber(reader.int64());
                    break;
                case 4:
                    message.fileSha1 = reader.string();
                    break;
                case 5:
                    message.s3ExifData = exports.S3ExifData.decode(reader, reader.uint32());
                    break;
                case 6:
                    message.s3UploadData = exports.S3UploadData.decode(reader, reader.uint32());
                    break;
                case 7:
                    message.thumbnailPath = reader.string();
                    break;
                case 8:
                    message.thumbnailSize = longToNumber(reader.int64());
                    break;
                case 9:
                    message.imageHeight = longToNumber(reader.int64());
                    break;
                case 10:
                    message.imageWidth = longToNumber(reader.int64());
                    break;
                case 100:
                    message.errorCode = reader.int32();
                    break;
                case 101:
                    message.errorMessage = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            correlationId: isSet(object.correlationId)
                ? String(object.correlationId)
                : "",
            filePath: isSet(object.filePath) ? String(object.filePath) : "",
            fileSize: isSet(object.fileSize) ? Number(object.fileSize) : 0,
            fileSha1: isSet(object.fileSha1) ? String(object.fileSha1) : "",
            s3ExifData: isSet(object.s3ExifData)
                ? exports.S3ExifData.fromJSON(object.s3ExifData)
                : undefined,
            s3UploadData: isSet(object.s3UploadData)
                ? exports.S3UploadData.fromJSON(object.s3UploadData)
                : undefined,
            thumbnailPath: isSet(object.thumbnailPath)
                ? String(object.thumbnailPath)
                : "",
            thumbnailSize: isSet(object.thumbnailSize)
                ? Number(object.thumbnailSize)
                : 0,
            imageHeight: isSet(object.imageHeight) ? Number(object.imageHeight) : 0,
            imageWidth: isSet(object.imageWidth) ? Number(object.imageWidth) : 0,
            errorCode: isSet(object.errorCode) ? Number(object.errorCode) : 0,
            errorMessage: isSet(object.errorMessage)
                ? String(object.errorMessage)
                : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.correlationId !== undefined &&
            (obj.correlationId = message.correlationId);
        message.filePath !== undefined && (obj.filePath = message.filePath);
        message.fileSize !== undefined &&
            (obj.fileSize = Math.round(message.fileSize));
        message.fileSha1 !== undefined && (obj.fileSha1 = message.fileSha1);
        message.s3ExifData !== undefined &&
            (obj.s3ExifData = message.s3ExifData
                ? exports.S3ExifData.toJSON(message.s3ExifData)
                : undefined);
        message.s3UploadData !== undefined &&
            (obj.s3UploadData = message.s3UploadData
                ? exports.S3UploadData.toJSON(message.s3UploadData)
                : undefined);
        message.thumbnailPath !== undefined &&
            (obj.thumbnailPath = message.thumbnailPath);
        message.thumbnailSize !== undefined &&
            (obj.thumbnailSize = Math.round(message.thumbnailSize));
        message.imageHeight !== undefined &&
            (obj.imageHeight = Math.round(message.imageHeight));
        message.imageWidth !== undefined &&
            (obj.imageWidth = Math.round(message.imageWidth));
        message.errorCode !== undefined &&
            (obj.errorCode = Math.round(message.errorCode));
        message.errorMessage !== undefined &&
            (obj.errorMessage = message.errorMessage);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
        const message = createBaseS3ProcessResult_Result();
        message.correlationId = (_a = object.correlationId) !== null && _a !== void 0 ? _a : "";
        message.filePath = (_b = object.filePath) !== null && _b !== void 0 ? _b : "";
        message.fileSize = (_c = object.fileSize) !== null && _c !== void 0 ? _c : 0;
        message.fileSha1 = (_d = object.fileSha1) !== null && _d !== void 0 ? _d : "";
        message.s3ExifData =
            object.s3ExifData !== undefined && object.s3ExifData !== null
                ? exports.S3ExifData.fromPartial(object.s3ExifData)
                : undefined;
        message.s3UploadData =
            object.s3UploadData !== undefined && object.s3UploadData !== null
                ? exports.S3UploadData.fromPartial(object.s3UploadData)
                : undefined;
        message.thumbnailPath = (_e = object.thumbnailPath) !== null && _e !== void 0 ? _e : "";
        message.thumbnailSize = (_f = object.thumbnailSize) !== null && _f !== void 0 ? _f : 0;
        message.imageHeight = (_g = object.imageHeight) !== null && _g !== void 0 ? _g : 0;
        message.imageWidth = (_h = object.imageWidth) !== null && _h !== void 0 ? _h : 0;
        message.errorCode = (_j = object.errorCode) !== null && _j !== void 0 ? _j : 0;
        message.errorMessage = (_k = object.errorMessage) !== null && _k !== void 0 ? _k : "";
        return message;
    },
};
function createBaseS3UploadStatusData() {
    return { correlationId: "", orderNumber: undefined, propertyId: undefined };
}
exports.S3UploadStatusData = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.correlationId !== "") {
            writer.uint32(10).string(message.correlationId);
        }
        if (message.orderNumber !== undefined) {
            writer.uint32(800).int64(message.orderNumber);
        }
        if (message.propertyId !== undefined) {
            writer.uint32(808).int64(message.propertyId);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseS3UploadStatusData();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.correlationId = reader.string();
                    break;
                case 100:
                    message.orderNumber = longToNumber(reader.int64());
                    break;
                case 101:
                    message.propertyId = longToNumber(reader.int64());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            correlationId: isSet(object.correlationId)
                ? String(object.correlationId)
                : "",
            orderNumber: isSet(object.orderNumber)
                ? Number(object.orderNumber)
                : undefined,
            propertyId: isSet(object.propertyId)
                ? Number(object.propertyId)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.correlationId !== undefined &&
            (obj.correlationId = message.correlationId);
        message.orderNumber !== undefined &&
            (obj.orderNumber = Math.round(message.orderNumber));
        message.propertyId !== undefined &&
            (obj.propertyId = Math.round(message.propertyId));
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c;
        const message = createBaseS3UploadStatusData();
        message.correlationId = (_a = object.correlationId) !== null && _a !== void 0 ? _a : "";
        message.orderNumber = (_b = object.orderNumber) !== null && _b !== void 0 ? _b : undefined;
        message.propertyId = (_c = object.propertyId) !== null && _c !== void 0 ? _c : undefined;
        return message;
    },
};
var globalThis = (() => {
    if (typeof globalThis !== "undefined")
        return globalThis;
    if (typeof self !== "undefined")
        return self;
    if (typeof window !== "undefined")
        return window;
    if (typeof global !== "undefined")
        return global;
    throw "Unable to locate global object";
})();
function toTimestamp(date) {
    const seconds = date.getTime() / 1000;
    const nanos = (date.getTime() % 1000) * 1000000;
    return { seconds, nanos };
}
function fromTimestamp(t) {
    let millis = t.seconds * 1000;
    millis += t.nanos / 1000000;
    return new Date(millis);
}
function fromJsonTimestamp(o) {
    if (o instanceof Date) {
        return o;
    }
    else if (typeof o === "string") {
        return new Date(o);
    }
    else {
        return fromTimestamp(timestamp_1.Timestamp.fromJSON(o));
    }
}
function longToNumber(long) {
    if (long.gt(Number.MAX_SAFE_INTEGER)) {
        throw new globalThis.Error("Value is larger than Number.MAX_SAFE_INTEGER");
    }
    return long.toNumber();
}
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
